﻿using System;
using System.Windows;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Anwendungen_des_Codebehinds.ViewModelBase;
using System.Collections.ObjectModel;
using System.IO;
using System.Diagnostics;

namespace Anwendungen_des_Codebehinds.ViewModels {
   class MainViewModel : PropertyChangedBase {
      private static MainViewModel _instance;
      public static MainViewModel Instance {
         get {
            if (_instance == null)
               _instance = new MainViewModel();
            return _instance;
         }
      }


      public void Loaded() {
         Files = new ObservableCollection<FileInfo>();
      }

      public void Drop(string[] files) {
         foreach (string file in files)
            Files.Add(new FileInfo(file));
      }

      private RelayCommand openfile;
      public RelayCommand OpenFile {
         get {
            if (openfile == null) openfile = new RelayCommand((o) => { Process.Start(SelectedFile.FullName); });
            return openfile;
         }
      }

      private RelayCommand openfolder;
      public RelayCommand OpenFolder {
         get {
            if (openfolder == null)
               openfolder = new RelayCommand((o) => { Process.Start("explorer.exe", string.Format("/select, {0}", SelectedFile.FullName)); });
            return openfolder;
         }
      }

      private RelayCommand deletefile;
      public RelayCommand DeleteFile {
         get {
            if (deletefile == null)
               deletefile = new RelayCommand((o) => { SelectedFile.Delete(); Files.Remove(SelectedFile); });
            return deletefile;
         }
      }
      private RelayCommand _ItemsDropCommand;
      public RelayCommand ItemsDropCommand {
         get {
            if (_ItemsDropCommand == null) _ItemsDropCommand = new RelayCommand(ItemsDropped);
            return _ItemsDropCommand;
         }
      }
      private void ItemsDropped(object o) {
      System.Windows.MessageBox.Show("Somethings's dropped!");
      }

      private ObservableCollection<FileInfo> files;
      public ObservableCollection<FileInfo> Files {
         get { return files; }
         set {
            SetProperty(value, ref files);
         }
      }


      private FileInfo selectedfile;
      public FileInfo SelectedFile {
         get { return selectedfile; }
         set {
            SetProperty(value, ref selectedfile);
         }
      }
   }
}
